function line_ratio(MAXLEV,energy,aij,b,NUP,utrn,NLOW,ltrn)
! As the name says, it calculates line ratios.  The only interesting bit is
! that any number of lines can be combined.  utrn/NUP and ltrn/NLOW control
! the lines involved.  utrn/ltrn is essentially a vector with the indices
! of the lower and upper levels for each line.
  use precision
  implicit none
  integer i,j,nt,MAXLEV,NUP,NLOW,utrn(2,NUP),ltrn(2,NLOW)
  real(long) :: b(MAXLEV),aij(MAXLEV,MAXLEV),energy(MAXLEV)
  real(long) :: line_ratio,upper,lower
  upper=0.d0
  lower=0.d0
! NUP is the number of lines in the upper part of the ratio
  do nt=1,NUP
! lower level    
    i=utrn(1,nt)
! upper level    
    j=utrn(2,nt)
    upper=upper+b(j)*aij(j,i)
  enddo
! Similarly for the lower term  
  do nt=1,NLOW
    i=ltrn(1,nt)
    j=ltrn(2,nt)
    lower=lower+b(j)*aij(j,i)
  enddo
  line_ratio=upper/lower
  return
end
  
