use precision
! This is a simple driver program to produce line ratios.  At the moment some
! parts are hardwired but this isn't a necessity.  Reading in utrn and ltrn,
! defining them in parameter statements  or making them part of the model atom
! description (probably best) would all take care of this
! compile using
! ifort -o linedat precision.f90 read_atom.f90 setup_rates.f90 ludcmp.f90 lubksb.f90 line_ratio.f90
implicit none
integer,parameter :: MAXLEV=10,MAXTR=10
integer :: i,j,n,nt,indx(MAXLEV),utrn(2,MAXTR),ltrn(2,MAXTR),len_atom
character :: lab(MAXLEV)*5,filename*8,atom*4
real(long) :: weight(MAXLEV),energy(MAXLEV),ups(MAXLEV,MAXLEV),aij(MAXLEV,MAXLEV)
real(long) :: ne,t,d,line_ratio,logne,del
real(long) :: a(MAXLEV,MAXLEV),b(MAXLEV)
write(*,*) 'which atom would you like to treat, oiii or oii'
read(*,*) atom
! this is necessary to remove trailing blanks
do i=4,1,-1
  if(atom(i:i).ne.' ') go to 10
enddo
! construct the filename from the atom label
10 len_atom=i
filename=atom(1:len_atom)//'.dat'
call read_atom(filename,MAXLEV,n,lab,weight,energy,ups,aij)
if(atom(1:len_atom).eq.'oiii') then
  write(*,*) 'An electron density?: 1.e1-1.e6'
  read(*,*) ne
  nt=15
  do i = 1, nt
    t=6000.d0+(i-1)*1000.d0
    call setup_rates(MAXLEV,n,weight,energy,ups,aij,ne,t,a,b)
    call ludcmp(a,n,MAXLEV,indx,d)
    call lubksb(a,n,MAXLEV,indx,b)
    utrn(1,1)=3
    utrn(2,1)=4
    utrn(1,2)=2
    utrn(2,2)=4
    ltrn(1,1)=4
    ltrn(2,1)=5
    write(*,*) t,line_ratio(MAXLEV,energy,aij,b,2,utrn,1,ltrn)
  enddo
else
  write(*,*) 'A temperature: 5000-40000 K'
  read(*,*) t
  nt=13
  ne=1.d0
  del=log10(2.d0)
  do i = 1, nt
    logne=1.d0+(i-1)*del
    ne=10.d0**logne
    call setup_rates(MAXLEV,n,weight,energy,ups,aij,ne,t,a,b)
    call ludcmp(a,n,MAXLEV,indx,d)
    call lubksb(a,n,MAXLEV,indx,b)
    utrn(1,1)=1
    utrn(2,1)=2
    ltrn(1,1)=1
    ltrn(2,1)=3
    write(*,*) ne,line_ratio(MAXLEV,energy,aij,b,1,utrn,1,ltrn)
  enddo
endif
stop
end


